Uses Cfg
Uses User

Type
  RecFileBase = Record
    Index      : Word;          // change to longint?
    Name       : String[40];         // change to 70?
    FtpName    : String[60];
    FileName   : String[40];
    DisplayFile: String[20];
    Template   : String[20];
    ListACS    : String[30];
    FtpACS     : String[30];
    DLACS      : String[30];
    ULACS      : String[30];
    HatchACS   : String[30];
    SysOpACS   : String[30];
    Path       : String[80];
    DefScan    : Byte;
    Flags      : LongInt;
    Created    : LongInt;
    NetAddr    : Byte;
    EchoTag    : String[30];
  End;

Type
  RecFileList = Record
    FileName  : String[70];
    Size      : LongInt;
    DatTim  : LongInt;
    Uploader  : String[30];
    Flags     : Byte;
    Downloads : LongInt;
    Rating    : Byte;
    DescPtr   : Cardinal;
    DescLines : Byte;
  End;

Type TTFileRec = Record
	Uler	: String
	FName	: String
	Conf	: String
	Size	: LongInt
	DTme	: LongInt
End;

Var fbinfo: RecFileBase
Var flist	: RecFileList
Var TF		: Array [1..21] Of TTFileRec
Var Rows	: Integer = 20

Function ReadFileBases(FBNum:Integer):Boolean
Var Ret	: Boolean = False
Var fptr: File
Begin
	fAssign(fptr,CfgDataPath+'fbases.dat',66)
	fReset(fptr)
	If IoResult = 0 Then Begin
		fSeek(fptr,(FBNum-1)*SizeOf(fbinfo))
		If Not fEof(Fptr) Then Begin
			fReadRec(Fptr,fbinfo)
			Ret:=True
		End
		fClose(fptr)
	End
	ReadFileBases:=Ret
End

Function ReadFileList(FBName:String;FBNum:Integer):Boolean
Var Ret		: Boolean = False
Var Fptr	: File
Begin
	fAssign(Fptr,CfgDataPath+FBname+'.dir',66)
	fReset(Fptr)
	If IoResult = 0 Then Begin
		fSeek(fptr,(FBNum-1)*SizeOf(FList))
		If Not fEof(Fptr) Then Begin
			FReadRec(fptr,FList)
			Ret:=True
		End
		fClose(Fptr)
	End
	ReadFileList:=Ret
End

Procedure InsertFile(ul,fn,conf:string;sz,dt:longint)
Var X,Y,Z	: Integer
Var Tmpx	: TTFileRec
Var TY		: TTFileRec
Begin
	TY.ULer:=ul
	TY.fName:=fn
	TY.Conf:=conf
	TY.size:=sz
	TY.Dtme:=dt

	TF[21]:=TY

	For X:=21 Down To 2 Do Begin
		If TF[X].DTme >= TF[X-1].DTme Then Begin
			Tmpx:=TF[X-1]
			TF[X-1]:=TF[X]
			TF[X]:=TmpX
		End
	End
End

Function Size2Str(LI:LongInt;w1:Integer):String
Var DX,Ret	: String
Var SX			: Array [1..5] of Char
Var V,Z,Y,X	: LongInt
Var D				: Integer
Begin
	SX[1]:='b'
	SX[2]:='k'
	SX[3]:='m'
	SX[4]:='g'
	X:=LI
	Z:=1
	Y:=1
	Repeat
		X:=X/1000
		Z:=Z*1000
		Y:=Y+1
	Until X <= 1000
	DX:=Int2Str(LI-(X*Z))	
	Ret:=Int2Str(X)+'.'+Copy(DX,1,W1)+SX[Y]
	Size2Str:=Ret
End

Procedure Main
Var X,Y,A,Z	: Integer
Var TT	: TTFileRec
Var Sz	: String
Begin
	TT.FName:='BLANK'
	TT.Dtme:=0
	TT.Size:=0
	TT.Conf:='None'
	TT.ULer:='None'
	For X:=1 To 20 Do Begin
		TF[X]:=TT
	End
	X:=1
	While ReadFileBases(X) Do Begin
		Y:=1
		While ReadFileList(fbinfo.FileName,Y) Do Begin
			InsertFile(FList.Uploader,FList.FileName,FBInfo.Name,FList.Size,FList.DatTim)
			Y:=Y+1
		End
		X:=X+1
	End
	ClrScr
	DispFile('nftop')
	For A:=1 To Rows Do Begin
		Sz:=size2str(TF[A].Size,1)
		SetPromptInfo(1,TF[A].ULer)
		SetPromptInfo(2,TF[A].FName)
		SetPromptInfo(3,Sz)
		SetPromptInfo(4,StripMCI(TF[A].Conf))
		SetPromptInfo(5,DateStr(TF[A].DTme,1))
		SetPromptInfo(6,TimeStr(TF[A].DTme,True))
		DispFile('nfmid')	
	End
	DispFile('nfbot')
End

Begin
	GetThisUser
	If ParamCount > 0 Then
		Rows:=Str2Int(ParamStr(1))
	If Rows > 20 Then Rows:=20
	Main
End
